'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function arrify(value) {
  return Array.isArray(value) ? value : [value];
}

function createEvents(eventDefinitions, prevState, action) {
  var eventCollection = [];
  arrify(eventDefinitions).forEach(function (_ref) {
    var eventFields = _ref.eventFields,
        eventSchema = _ref.eventSchema;

    if (typeof eventFields !== 'function') {
      return null;
    }
    var events = arrify(eventFields(action, prevState)).map(function (event) {
      if (eventSchema !== undefined && (typeof event === 'undefined' ? 'undefined' : _typeof(event)) === 'object') {
        var eventPropIsValid = function eventPropIsValid(prop) {
          return eventSchema[prop](event[prop]);
        };
        var isValidEvent = Object.keys(eventSchema).every(eventPropIsValid);
        return isValidEvent ? event : null;
      }

      return event;
    }).filter(function (event) {
      return event !== null && event !== undefined;
    });

    return eventCollection.push.apply(eventCollection, _toConsumableArray(events));
  });
  return eventCollection;
}

module.exports = createEvents;